#!/usr/bin/python
# -*- coding: utf-8 -*-


def encode_javascript(s):
    try:
        return s.encode('ascii', 'backslashreplace')
    except UnicodeEncodeError:
        return s

def encode_xml_entity(data):
    try:
        return data.encode('ascii', 'xmlcharrefreplace')
    except UnicodeEncodeError:
        return data

def anti_crab(data, contenttype, encoding):
    if encoding:
        data = data.decode(encoding)
    else:
        for code in ('utf8', 'gbk', 'big5'):
            try:
                data = data.decode(code)
                break
            except UnicodeEncodeError:
                pass

    _buffer = []
    last = 0
    in_script = False
    if contenttype.find('javascript') >= 0:
        return encode_javascript(data)

    lower_data = data.lower()
    while True:
        if in_script:
            i = lower_data.find('</script>', last)
            if i < 0:
                i = len(data)
                _buffer.append(encode_javascript(data[last:i]))
                break
            _buffer.append(encode_javascript(data[last:i]))
            last = i
            in_script = False
        else:
            i = lower_data.find('<script', last)
            if i < 0:
                _buffer.append(encode_xml_entity(data[last:]))
                break
            _buffer.append(encode_xml_entity(data[last:i]))
            in_script = True
            last = i
    return ''.join(_buffer)


